// TODO: can we get rid of this because effect schema already has an annotation for the constructor?
export const constructorOfSchemaSym = Symbol.for("@jazz/constructorOfSymbol");
export function propertyIsCoValueSchema(prop) {
    if ("propertySignatureAST" in prop) {
        return astIsCoValueSchema(prop.propertySignatureAST.from);
    }
    else {
        return astIsCoValueSchema(prop.ast);
    }
}
function astIsCoValueSchema(ast) {
    if ((ast._tag === "Declaration") &&
        ast.annotations[constructorOfSchemaSym]) {
        return true;
    }
    else if (ast._tag === "Union") {
        return ast.types.every((member) => member._tag === "UndefinedKeyword" || astIsCoValueSchema(member));
    }
    else if (ast._tag === "BooleanKeyword" ||
        ast._tag === "NumberKeyword" ||
        ast._tag === "StringKeyword" ||
        ast._tag === "Literal" ||
        ast._tag === "Tuple") {
        return false;
    }
    else if (ast._tag === "Refinement") {
        return astIsCoValueSchema(ast.from);
    }
    else if (ast._tag === "Transform") {
        return astIsCoValueSchema(ast.from);
    }
    else {
        throw new Error(`astIsCoValueSchema can't yet handle ${ast._tag}: ${JSON.stringify(ast)}`);
    }
}
export function getCoValueConstructorInProperty(prop, rawValue) {
    if ("propertySignatureAST" in prop) {
        return getCoValueConstructorInAST(prop.propertySignatureAST.from, rawValue);
    }
    else {
        return getCoValueConstructorInAST(prop.ast, rawValue);
    }
}
// TODO (optimization): make this meta, so this creates a tailor-made function that will take a RawCoValue at call time
function getCoValueConstructorInAST(ast, rawValue) {
    if ((ast._tag === "Declaration") &&
        ast.annotations[constructorOfSchemaSym]) {
        return ast.annotations[constructorOfSchemaSym];
    }
    else if (ast._tag === "Union" && ast.types.length === 2) {
        const [a, b] = ast.types;
        if (a._tag === "UndefinedKeyword") {
            return getCoValueConstructorInAST(b, rawValue);
        }
        else if (b._tag === "UndefinedKeyword") {
            return getCoValueConstructorInAST(a, rawValue);
        }
        else {
            throw new Error(`getCoValueConstructorInAST can't yet handle Union of: ${JSON.stringify(ast.types)}`);
        }
    }
    else {
        throw new Error(`getCoValueConstructorInAST can't yet handle ${ast._tag}: ${JSON.stringify(ast)}`);
    }
}
//# sourceMappingURL=resolution.js.map