import { Account, Co, ImageDefinition, S, jazzReady } from "..";
import { describe, test, beforeEach, expectTypeOf } from "vitest";
import { webcrypto } from "node:crypto";
if (!("crypto" in globalThis)) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    globalThis.crypto = webcrypto;
}
beforeEach(async () => {
    await jazzReady;
});
class TestMap extends Co.map({
    name: S.string,
    image: Co.media.imageDef,
    maybeImage: S.optional(Co.media.imageDef),
}).as() {
}
describe("CoMap type tests", () => {
    test("Optional field refs work", async () => {
        const me = await Account.create({
            name: "Hermes Puggington",
        });
        const map = new TestMap({
            name: "Hermes",
            image: new ImageDefinition({
                originalSize: [100, 100],
                placeholderDataURL: "data:image/png;base64,",
            }, { owner: me }),
        }, { owner: me });
        expectTypeOf(map._refs.image).toMatchTypeOf();
        expectTypeOf(map._refs.maybeImage).toMatchTypeOf();
    });
});
//# sourceMappingURL=types.test.js.map